//
// (c) 1994 Jonathan Cloots
//


#include "pb_sdk.h"

typedef struct {
    char name[36];      /* Name of user online                                 */
    char city[16];      /* City of user online                                 */
    int baud;           /* Baud rate of user                                   */
    int status;         /* 0 -> online , <0 -> not online or unavailable       */
    char extra[8];
} ONLINE;

void main(void) {
    int fp;
    ONLINE *o;
    byte CfgName[61];
    byte OnlinePro[61];
    byte NodeMsgPath[61];
    byte Buf[4];
    byte Tonode;
    char Stats[256];
    byte Path[61];
    byte Line[61],i;
    bool Ok;

    o = (ONLINE *) malloc(sizeof(ONLINE));

    sprintf(CfgName,"%sSSMCU.INI",Config->pexpath);

    Ok=GetIniVar(CfgName,"OnlinePro",OnlinePro,61); if(!Ok) { printf("\x11 Error!"); Log(LOG_FRIEND,"Could not read SSMCU.INI - 'OnlinePro'"); return; }
    Ok=GetIniVar(CfgName,"NodeMsgPath",NodeMsgPath,61); if(!Ok) { printf("\x11 Error!"); Log(LOG_FRIEND,"Could not read SSMCU.INI - 'NodeMsgPath'"); return; }

    fp=open(OnlinePro,O_RDONLY|O_DENYNONE);
    if(fp==-1) { printf("\x11- Error -"); Log(LOG_FRIEND,"Could Not Open Online.PRO"); return; }

    printf("\f\7Select node\4\n");
    for(i=0;i<79;i++) putchar(196);
    printf("\n\6 Node \2Name                                \4City\4\n");
    for(i=0;i<79;i++) putchar(196);
    printf("\n");

    for(i=0;i<Config->numnodes;i++) {
        lseek(fp,i*sizeof(ONLINE),SEEK_SET);
        read(fp,o,sizeof(ONLINE));

        Stats[i]=o->status;
        if(o->status==0) {
            if(o->name[0]==0) goto n;
            if(o->city[0]==0) goto n;
            printf("  \6%3d \2%-35s \4%-16s\n",i+1,o->name,o->city);
        } else {
            n: printf("  \6%3d \2Not Available\n",i+1);
            Stats[i]=1;
        }
    }

    printf("\4");
    for(i=0;i<79;i++) putchar(196);
    printf("\n");
    printf("\7Node \6: ");
    SetFullColor(0x1f);
    Input(Buf,4,INPUT_ALL);
    Tonode=atoi(Buf);
    printf("\n");
    close(fp);
    
    if((Tonode<=0) || (Tonode>Config->numnodes)) {
        printf("\n\1Operation Cancelled.");
        delay(2000);
        return;
    }
    if(Tonode==NodeNumber) {
        printf("\n\1You are on that node.");
        delay(2000);
        return;
    }
    if(Stats[Tonode-1]!=0) {
        printf("\n\1That node is not available.");
        delay(2000);
        return;
    }

    sprintf(Path,"%sNode_%d.MSG",NodeMsgPath,Tonode);
    if(access(Path,F_OK)!=0) {
        close(creat(Path,S_IREAD|S_IWRITE));
    }
    fp=open(Path,O_WRONLY|O_DENYNONE);
    if(fp==-1) {
        printf("\x11  File Error on line %d! \7[\3Enter\7]\t",(__LINE__)-2);
        exit();
    }
    lseek(fp,0,SEEK_END);

    sprintf(Line,"\n\n\n");
    write(fp,Line,strlen(Line));
    sprintf(Line," SplitScreen Multiline Chat Utility (c) 1994 Jonathan Cloots\n");
    write(fp,Line,strlen(Line));
    sprintf(Line,"\n");
    write(fp,Line,strlen(Line));
    sprintf(Line," User %s on node %d Sends this message\n",CurUser->name,NodeNumber);
    write(fp,Line,strlen(Line));
    sprintf(Line,"\n");
    write(fp,Line,strlen(Line));
    printf("\f\n\n\4Enter your message here, enter on an empty line to stop...\n\n");
    while(*Line!=0) {
        printf("\7> \6");
        Input(Line,61,INPUT_ALL);
        strcat(Line,"\n");
        write(fp,Line,strlen(Line));
        printf("\n");
        if(strlen(Line)<2) {
            break;
        }
    }
    printf("\nThank you for this gratious act of messaging... \7[\3Enter\7]\t\n");
    sprintf(Line,"\n"); write(fp,Line,strlen(Line));
    printf("\n");
    close(fp);
}

